(defun c:movel () ; define-se uma função movel que cria dois móveis agregados. O móvel de baixo pode incluir uma base e portas ou sem elas defenir uma secretária. O móvel de cima inclui o número de prateleiras definido.

(setq pontos2d (getvar "osmode")) ; é alterado o modo de desenho do AutoCAD de tridimensional para bidimensional 
(setq pontos3d (getvar "3dosmode"))
(setvar "osmode" 0)
(setvar "3dosmode" 0)

(setq pt1 (getpoint "indique o ponto de insercao: ")) ; é pedido o ponto a partir do qual será definido o móvel na função modelar

(If (= nil
(setq comprimento (getreal " indique o comprimento (em x):"))) ; neste e nos próximos parágrafos serão pedidas as informações como a largura, comprimento,... do móvel
(setq comprimento 1.50)) ; é ainda definida uma resposta padrão no caso de o utlizador não responder

(If (= nil
(setq largura1 (getreal "indique a largura do movel de baixo (em y): ")))
(setq largura1 0.50))

(If (= nil
(setq largura2 (getreal "indique a largura do movel de cima (em y): ")))
(setq largura2 0.30))

(If (= nil
(setq altura1 (getreal "indique a altura do movel de baixo (em z): ")))
(setq altura1 0.50))

(If (= ""
(setq base (getstring "incluir base no movel de baixo? (S/N): ")))
(setq base "s"))

(If (= ""
(setq portas (getstring "incluir portas no movel de baixo? (S/N): ")))
(setq portas "s"))

(If (= nil
(setq altura2 (getreal "indique a altura do movel de cima (em z): ")))
(setq altura2 1.00))

(If (= nil
(setq esp1 (getreal "indique a espessura de cada prateleira: ")))
(setq esp1 0.05))

(If (= nil
(setq prateleiras (getreal "indique o número de prateleiras do movel de cima: ")))
(setq prateleiras 3))

(setq h (/ (- altura2 (* (+ prateleiras 1) esp1)) (+ prateleiras 1))) ; h define a altura entre prateleiras


(modelar)
(setvar "osmode" pontos2d) ; é restaurado o modo de criação de objetos bidimensionais no plano XY e o modo de criação de objetos tridimensionais para seus valores originais
(setvar "3dosmode" pontos3d)
(command "ucs" "") ; é definido o sistema de coordenadas de usuário como o sistema padrão
(command "shade") ; altera o visual style para shaded
)

(defun modelar () ; é chamada a função modelar onde será concretizado o móvel
(command "ucs" pt1 "") ; o UCS é alterado para as coordenadas do ponto de inserção

(if (or (equal portas "S") (equal portas "s"))
    (progn
        (command "box" (list 0 0 0) (list (/ comprimento 2) (- esp1) altura1)) ; no caso de o utilizador escolher que o móvel de baixo tem portas, não só estas são definidas como a sua espessura é descontada na largura 
        (setq porta1 (entlast))
        (command "box" (list (/ comprimento 2) 0 0) (list comprimento (- esp1) altura1))
        (setq porta2 (entlast))
        (setq largura1 (- largura1 esp1))
    ))

(command "box" (list 0 0 (- altura1 esp1)) (list esp1 largura1 0)) ; é definida a trave lateral esquerda do móvel de baixo que se associa a traveesq
(setq traveesq (entlast))

(command "box" (list (- comprimento esp1) 0 (- altura1 esp1)) (list comprimento largura1 0)) ; é definida a trave lateral direita do móvel de baixo que se associa a travedir
(setq travedir (entlast))

(command "box" (list esp1 (- largura1 esp1) (- altura1 esp1)) (list (- comprimento esp1) largura1 0)) ; é definida a placa de trás do móvel de baixo que se associa a plcatras
(setq plcatras (entlast))

(if (or (equal base "S") (equal base "s"))
    (progn
        (command "box" (list esp1 0 0) (list (- comprimento esp1) largura1 esp1)) ; no caso de o utlizador optar por incluir uma placa base ao móvel de baixo, esta será agora definida e associada a basebaixo
        (setq basebaixo (entlast))
    ))


(command "box" (list 0 0 (- altura1 esp1)) (list comprimento largura1 altura1)) ; é definido o tampo do móvel de baixo que se associa a tampobaixo
(setq tampobaixo (entlast))

(command "box" (list 0 (- largura1 largura2) altura1) (list esp1 largura1 (+ altura1 (- altura2 esp1)))) ; é definida a trave lateral esquerda do móvel de cima que se associa a traveesq2
(setq traveesq2 (entlast))

(command "box" (list (- comprimento esp1) (- largura1 largura2) altura1) (list comprimento largura1 (+ altura1 (- altura2 esp1)))) ; é definida a trave lateral direita do móvel de cima que se associa a travedir2
(setq travedir2 (entlast))

(command "box" (list esp1 (- largura1 esp1) altura1) (list (- comprimento esp1) largura1 (+ altura1 (- altura2 esp1)))) ; é definida a placa de trás do móvel de cima que se associa a plcatras2
(setq plcatras2 (entlast))

(command "box" (list 0 (- largura1 largura2) (+ altura1 (- altura2 esp1))) (list comprimento largura1 (+ altura1 altura2))) ; é definido o tampo do móvel de cima que se associa a tampocima
(setq tampocima (entlast))

(command "box" (list esp1 (- largura1 largura2) (+ altura1 h)) (list (- comprimento esp1) (- largura1 esp1) (+ altura1 h esp1))) ; é definida a primeira prateleira do móvel de cima que se associa a prateleira1
(setq prateleira1 (entlast))

(command "UCS" (list 0 0 0) (list 1 0 0) (list 0 0 1)) ; é rodado o UCS de modo a ser possivel fazer o comando aray em Z

(command "array" prateleira1 "" "r" prateleiras 1 (+ h esp1)) ; é repetida a primeira prateleira em função do número pretendido

(command "union" traveesq travedir basebaixo plcatras plcatras2 tampobaixo tampocima traveesq2 travedir2 "") ; é feita a união dos diversos elementos do móvel

)